package su.a71.new_soviet.mixin;

import net.minecraft.block.AbstractBlock;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.*;
import net.minecraft.sound.SoundCategory;
import net.minecraft.util.ActionResult;
import net.minecraft.util.Hand;
import net.minecraft.util.math.BlockPos;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import su.a71.new_soviet.NewSoviet;
import su.a71.new_soviet.registration.NSE_Items;
import su.a71.new_soviet.registration.NSE_Sounds;

@Mixin(BrushItem.class)
public class BrushMixin {
    protected BrushMixin(AbstractBlock.Settings settings) {
        super();
    }

    @Inject(method = "useOnBlock", at = @At("HEAD"))
    private void use(ItemUsageContext context, CallbackInfoReturnable<ActionResult> cir) {
        Hand hand = context.getHand();
        PlayerEntity user = context.getPlayer();
        if (user.getOffHandStack().getItem() == NSE_Items.WHITEWASH_ITEM) {
            user.getInventory().setStack(user.getInventory().selectedSlot, NSE_Items.WHITEWASHED_BRUSH.getDefaultStack());
            user.getOffHandStack().damage(100, user, (p) -> {
                p.sendToolBreakStatus(hand);
            });
            context.getWorld().playSound(user, BlockPos.ofFloored(user.getPos()), NSE_Sounds.BRUSH_DIPPING_SOUND, SoundCategory.PLAYERS, 1, (float) NewSoviet.RANDOM.nextBetween(8, 11) / 10f);
        }
    }
}
